script.on_event(defines.events.on_player_created, function(event)
	makeGUI (event.player_index)
end)

script.on_event(defines.events.on_player_respawned, function(event)
	makeGUI (event.player_index)
end)


function handler_on_tick()
	if not global then global = {} end
	if not global.GUI then global.GUI = {} end
	for player_index, player in pairs (game.players) do
		if not (global.GUI[player_index]) then
			makeGUI (player_index)
			game.players[player_index].print ("GUI for you")
		end
	end
end

function make_item_list_with_nothing()
	if global.item_list_with_nothing == nil then 
		global.item_list_with_nothing = {}
		global.items = {}
		local i = 1
		global.item_list_with_nothing[i] = "nothing"
		
		for k, item in pairs (game.item_prototypes) do  
			i = i + 1
			global.item_list_with_nothing[i] = item.name
			global.items[item.name] = item
		end
	end
end

function makeGUI (player_index)
	--if (game.tick%30 == 0) then
		local player = game.players[player_index]
		-- make GUI frame
		if player.gui.left.frameCreative == nil then
			player.gui.left.add{type = "frame", name = "frameCreative", direction = "horizontal"}
		end
		-- set default settings
		if not global.GUI[player_index] then 
			global.GUI[player_index] = {}
			global.GUI[player_index].size = "mini"
			global.GUI[player_index].itemOrNothing = "nothing"
		end
		
		--check if list exists
		if not global.item_list_with_nothing then make_item_list_with_nothing() end

		if global.GUI[player_index].size == "mini" then
		-- clear the GUI and make mini GUI
			player.gui.left.frameCreative.destroy()
			player.gui.left.add{type = "frame", name = "frameCreative", direction = "horizontal"}
			
			player.gui.left.frameCreative.add{type ="table", name = "tabCreative", colspan = 2}
			local tab = player.gui.left.frameCreative.tabCreative
				tab.add{type = "label", name = "LabelMini", caption = "Placing item"}
				tab.add{type = "button", name = "openMaxi", caption = global.GUI[player_index].itemOrNothing}
		elseif global.GUI[player_index].size == "maxi" then
		-- clear the GUI and make maxi GUI
			player.gui.left.frameCreative.destroy()
			player.gui.left.add{type = "frame", name = "frameCreative", direction = "horizontal"}
			player.gui.left.frameCreative.add{type ="table", name = "tabCreative", colspan = 31}
			local tab = player.gui.left.frameCreative.tabCreative
				for i, value in pairs(global.item_list_with_nothing) do 
					if (i%30 == 2)and (i > 29) then tab.add{type = "label", name = "blank"..i, caption = " "..i.." "}  end
					if value == "nothing" then 
						tab.add{type = "button", name = value, caption = value}
					else
					tab.add{type = "sprite-button", name = value, caption = "    ", sprite  = "item/" .. value}
					end
				end
		end
	--end
end

script.on_event(defines.events.on_gui_click, function(event)
	local player_index = event.player_index or 1
	-- if not global then global = {} end
	-- if not global.GUI then global.GUI[player_index] = 1 end
	-- if not global.GUI[player_index] then global.GUI[player_index] = {} end
	-- if not global.GUI[player_index].size then global.GUI[player_index].size = "maxi" end
	
	if event.element.name == "openMaxi" then 
		global.GUI[player_index].size = "maxi"
		makeGUI (player_index)
		return
	end
		
	
	for i, value in pairs(global.item_list_with_nothing) do 
		if event.element.name == value then
			global.GUI[player_index].size = "mini"
			global.GUI[player_index].itemOrNothing = value
			makeGUI (player_index)
			return
		end
	end
end)










































